//+------------------------------------------------------------------+
//|                                                       Expert.mqh |
//|                   Copyright 2009-2017, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#include "Expert.mqh"
#include "SgSAR_TF.mqh"
#include "KKInfo.mqh"

#include <ChartObjects\ChartObjectsArrows.mqh>
//+------------------------------------------------------------------+
//| enumerations                                                     |
//+------------------------------------------------------------------+
extern double g_money_max_lots;
ENUM_MT_POLICY g_Big_State;
ENUM_MT_POLICY g_Small_State;
extern MqlTradeResult  hand_result;
//=============ID order position trace====================
extern CHashMap<ulong,uint> ea_order___group;
//=====================================
//+------------------------------------------------------------------+
//| Class CExpert.                                                   |
//| Purpose: Base class expert advisor.                              |
//| Derives from class CExpertBase.                                  |
//+------------------------------------------------------------------+
class CKExpert : public CExpert
  {
protected:
   CSignalSAR *filter1;
   CSignalSAR *filter2;
  // CExpertSignal    *m_signal;                   // trading signals object
  /* int               k_period_flags;             // timeframe flags (as visible flags)
   int               k_max_orders;               // max number of orders (include position)
   MqlDateTime       k_last_tick_time;           // time of last tick
   datetime          k_expiration;               // time expiration order
   //--- history info
   int               k_pos_tot;                  // number of open positions
   int               k_deal_tot;                 // number of deals in history
   int               k_ord_tot;                  // number of pending orders
   int               k_hist_ord_tot;             // number of orders in history
   datetime          k_beg_date;                 // start date of history
   //---
   int               k_waiting_event;            // flags of expected trade events
   //--- trading objects
   CExpertTrade     *k_trade;                    // trading object
   CExpertSignal    *k_signal;                   // trading signals object
   CExpertMoney     *k_money;                    // money manager object
   CExpertTrailing  *k_trailing;                 // trailing stops object
   bool              k_check_volume;             // check and decrease trading volume before OrderSend
   //--- indicators
   CIndicators       k_indicators;               // indicator collection to fast recalculations
   //--- market objects
   CPositionInfo     k_position;                 // position info object
   COrderInfo        k_order;                    // order info object
   //--- flags of handlers
   bool              k_on_tick_process;          // OnTick will be processed       (default true)
   bool              k_on_trade_process;         // OnTrade will be processed      (default false)
   bool              k_on_timer_process;         // OnTimer will be processed      (default false)
   bool              k_on_chart_event_process;   // OnChartEvent will be processed (default false)
   bool              k_on_book_event_process;    // OnBookEvent will be processed  (default false)
*/
   
   CExpertTrailing  *k_trailing2;                 // trailing stops object
  // CHashMap<ulong,CKEAInfo*> kea2_Order_Info;
  // CHashMap<ulong,CKEAInfo*> kea2_Deal_Info;
  // MqlTradeResult  OrderK_result; 
  // MqlTradeResult  DealK_result;  put in expert
  // MqlTradeResult  m_result;
  bool               m_new_order;
   CArrayObj         m_arrows;

  // uint              m_test_mode;
   uint              expert_policy;
   uint              m_timeout_small,m_timeout_big;
   bool              default_tailing_group;
public:
                     CKExpert(void);
                    ~CKExpert(void);
   CSymbolInfo*      panel_symbol;
                
   //--- initialization
 //  bool              Init(string symbol,ENUM_TIMEFRAMES period,bool every_tick,ulong magic=0);
   ENUM_TIMEFRAMES   m_op_Period_BIG; 
   ENUM_TIMEFRAMES   m_op_Period_SMALL;
   bool           Initfilter(CSignalSAR *fil1,CSignalSAR *fil2){ filter1=fil1;filter2=fil2; return (true);}
   void           OnChartEventProcess(bool value)        { m_on_chart_event_process=value; }
   void           SET_TEST_MODE(int mode){expert_policy = mode;}
   void           SetTimeOut(uint mins){m_timeout_small=mins;}
   void           SetTimeOutBig(uint mins){m_timeout_big=mins;}
   void           SetDefaultTF(bool big_s){default_tailing_group=big_s;}
   //--- methods of access to protected data
   CExpertSignal    *Signal(void)                     const { return(m_signal);               }
   //--- method of verification of settings
  // virtual bool      ValidationSettings();
   //--- method of creating the indicator and timeseries
   //virtual bool      InitIndicators(CIndicators *indicators=NULL);
   //--- event handlers
  // virtual void      OnTick(void);
  // virtual void      OnTrade(void);
   
   virtual void   OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam);
   virtual void   OnBookEvent(const string &symbol);
   virtual void   OnTrade(void);
   virtual void   OnTimer(void);
   virtual void   SetPeriod(ENUM_TIMEFRAMES Big,ENUM_TIMEFRAMES Small ){m_op_Period_SMALL=Small;m_op_Period_BIG=Big; }
   virtual bool   Init(string symbol,ENUM_TIMEFRAMES period,bool every_tick,ulong magic=0);
   virtual bool   InitIndicators(CIndicators *indicators=NULL);
   //virtual bool   InitTrailing(CKExpertTrailing *trailing0);//,CKExpertTrailing *trailing1=NULL
   virtual bool   CheckTrailingStop(ulong ticket);
   virtual bool   CheckTrailingStopLong(ENUM_TIMEFRAMES group);
   virtual bool   CheckTrailingStopShort(ENUM_TIMEFRAMES group);
   virtual bool   CheckTrailingStop(ENUM_POSITION_TYPE buy_sell,ENUM_TIMEFRAMES group);
   virtual bool   TrailingStop(ENUM_POSITION_TYPE buy_sell,double sl,double tp,ENUM_TIMEFRAMES group);
  // virtual bool   InitKTrailing(CTrailingPSAR *trailing=NULL);
   void Tailingflag(bool flag){flag_tailing  = flag ;}

protected:
   //--- initialization
  
      //--- trade open positions processing
   virtual bool OpenLong (double price,double sl,double tp,ENUM_MT_POLICY state,ENUM_TIMEFRAMES operation_priod);
   virtual bool OpenShort(double price,double sl,double tp,ENUM_MT_POLICY state,ENUM_TIMEFRAMES operation_priod);
   virtual bool ReverseLong (double price,double sl,double tp,ENUM_MT_POLICY state,ENUM_TIMEFRAMES operation_priod);
   virtual bool ReverseShort(double price,double sl,double tp,ENUM_MT_POLICY state,ENUM_TIMEFRAMES operation_priod);
   virtual double LotReverse(double sl,ENUM_TIMEFRAMES operation_priod);
   virtual ENUM_MT_POLICY      ckReverseLong(ENUM_TIMEFRAMES operation_priod);
   virtual ENUM_MT_POLICY      ckReverseShort(ENUM_TIMEFRAMES operation_priod);
   //--- refreshing 
  // virtual bool      Refresh(void);
   //--- position select depending on netting or hedging
  // virtual bool      SelectPosition(void);
   //--- processing (main method)
   virtual bool      Processing(void);
   //--- trade open positions check
   /*virtual bool      CheckOpen(void);
   virtual bool      CheckOpenLong(void);
   virtual bool      CheckOpenShort(void);
   //--- trade open positions processing
   virtual bool      OpenLong(double price,double sl,double tp);
    //--- delete order processing
   virtual bool      DeleteOrders(void);
   virtual bool      DeleteOrdersLong(void);
   virtual bool      DeleteOrdersShort(void);
   virtual bool      DeleteOrder(void);
   virtual bool      DeleteOrderLong(void);
   virtual bool      DeleteOrderShort(void);
 
   //--- lot for trade

   double            LotReverse(double sl);
   double            LotCheck(double volume,double price,ENUM_ORDER_TYPE order_type);
   //--- methods of working with trade history
   void              PrepareHistoryDate(void);
   void              HistoryPoint(bool from_check_trade=false);
   bool              CheckTradeState(void);
  */
   double          LotOpen(ENUM_POSITION_TYPE buy_sell,double price,double sl,ENUM_TIMEFRAMES op_priod);
   bool flag_tailing;
  };
//+------------------------------------------------------------------+
//| Constructor                                                      |
//+------------------------------------------------------------------+
CKExpert::CKExpert(void) 
  {
   
   m_new_order             = false;
   m_other_symbol          = true;
   m_other_period          = true;
   m_adjusted_point        = 10;
   m_period                = WRONG_VALUE;
   m_last_tick_time.min    = -1;
   m_op_Period_BIG   = PERIOD_H1;
   m_op_Period_SMALL = PERIOD_M5;
   m_timeout_small   = 55;
   
  }
//+------------------------------------------------------------------+
//| Destructor                                                       |
//+------------------------------------------------------------------+
CKExpert::~CKExpert(void)
  {
   Deinit();
  }
uint count_sar_dirchceck1=0;
bool CKExpert::Processing(void)
  {
//--- calculate signal direction once
   m_signal.SetDirection();
   // CIndicators *indicators_ptr=GetPointer(m_indicators);
//    indicators_ptr.At(0);      
   //--- check the possibility of closing the position/delete pending orders
//--- check if open positions
 //--- open position is available  reverse the position
   double   price =EMPTY_VALUE;
   double   sl,sl2    =0.0;      
   double   tp        =0.0;
   datetime expiration=TimeCurrent();
   MqlDateTime everynew ;
   TimeCurrent(everynew);
   int total=PositionsTotal();
   ulong ticket;
   if(total>0){
       for(int i=0;i<total;i++){
         if(m_position.SelectByIndex(i)){
           ticket=PositionGetTicket(i);// bool PositionSelect(_Symbol);
           //CheckTrailingStop(ticket);// true 要處理 tailing?     //   if(m_position.Select(m_symbol.Name()))
           uint group=0;
           if(ea_order__group.TryGetValue(ticket,group)){  
                  if(CheckTrailingStop(m_position.PositionType(),(ENUM_TIMEFRAMES)group))
                     return(true);
            }else{
                  Print(__FUNCTION__," ",ticket," nGroup: use def ",default_tailing_group);
                  if(default_tailing_group)
                     group=g_Big_State  ;
                  else  
                     group=g_Small_State;
                  if(CheckTrailingStop(m_position.PositionType(),(ENUM_TIMEFRAMES)group))
                     return(true);  
           }
           if(total>1)
             Print("======Tailing Check ~~ ",total,"ticket :", ticket);  
          }
       }    
   }else{
      //small_change_flag!=flag_sar_count;
   }
   g_money_max_lots=m_money.ShortSL(0.0);
  // filter1.UpdateBuffer();
   //sl = m_money.ShortSL(0.0);
   ENUM_MT_POLICY    state=MTP_HAND_;
   update_share_indicator();//filter2.update();
   //========================================處理大的時間週期=========================================================
   if(  expert_policy ==0x01|| expert_policy >2){//大週期 或是 兩者並行 
      bool pre_sl_check= m_money.SL_Open_Direction_Check(m_op_Period_BIG);
      if(flag_sar_direction==-1) {
         g_Big_State=P4_Con_S;
         flag_sar_direction =0;
         price = m_symbol.Bid();  
         if(pre_sl_check==false)//Tailing SAR 方向 可以處理的 
            count_sar_dirchceck1++;
         tp = m_money.Get_TP(m_op_Period_BIG,POSITION_TYPE_SELL);   
         sl = m_money.Get_SL(m_op_Period_BIG,POSITION_TYPE_SELL); // sl  = m_money.ShortSL(0.0,m_op_Period_BIG);    
         if(g_Big_State ==P3_Rev_L|| g_Big_State==P4_Con_S ||g_Big_State==P6_Cross_S){ //TODO 同方向 不關閉改用 open 
            //避免重入關掉又開啟同方向
            OpenShort(price,sl,tp,state,m_op_Period_BIG);      //避免重入關掉又開啟同方向
            //g_Big_State = state; 
         /*}else if(state==P3_Rev_L|| state==P4_Con_S ||state==P6_Cross_S){//不同方向            
            ReverseLong(price,sl,tp,state,m_op_Period_BIG);
            g_Big_State = state;
         */   
         }  
     }//if(flag_sar_direction){  
   
     if(flag_sar_direction==1) {
         g_Big_State=P2_Con_L;
         flag_sar_direction =0;
         price = m_symbol.Ask();
         if(pre_sl_check==true)   count_sar_dirchceck1++;  
         tp = m_money.Get_TP(m_op_Period_BIG,POSITION_TYPE_BUY);       
         sl = m_money.Get_SL(m_op_Period_BIG,POSITION_TYPE_BUY); //sl  = m_money.LongSL(0.0,m_op_Period_BIG); 
         if(g_Big_State ==P1_Rev_S || g_Big_State == P2_Con_L ||g_Big_State==P5_Cross_L ){           //TODO 同方向 不關閉改用 open 
                OpenLong(price,sl,tp,state,m_op_Period_BIG);      //避免重入關掉又開啟同方向
          //     g_Big_State = state;
       }/*else  if(state ==P1_Rev_S || state == P2_Con_L ||state==P5_Cross_L ){ //不同方向                      
           ReverseShort(price,sl,tp,state,m_op_Period_BIG);          //expiration
           g_Big_State = state;
      }  */
     }
   }
   //==========================處理小的時間週期======================================================
   
   if(  expert_policy >1 ){//小週期 或是 兩者並行 m_test_mode  == 2|| m_test_mode >2 
     //bool check_sl= m_money.SL_Open_Direction_Check(m_op_Period_SMALL);//Tailing SAR 方向 可以處理的
     
     state = filter2.MTF_CheckReverseLong(price,sl,tp,expiration);
     if(state != P0_CHECK ){//小週期期避免重入關掉又開啟同方向 && check_sl==true
      // double atr_sl = m_money.ShortSL(0.0,m_op_Period_SMALL);    //TODO 同方向 不關閉改用 open
         price = m_symbol.Bid();
         tp = m_money.Get_TP(m_op_Period_SMALL,POSITION_TYPE_SELL);
         sl = m_money.Get_SL(m_op_Period_SMALL,POSITION_TYPE_SELL); //short    
         
       if(g_Small_State ==P3_Rev_L|| g_Small_State==P4_Con_S ||g_Small_State==P6_Cross_S){ //TODO 同方向 不關閉改用 open 
         if(state==g_Small_State && total> 0)//避免重入關掉又開啟同方向
            printf("KK_Profolio Op reentrain "+ EnumToString(state) );
         else{
            OpenShort(price,sl,tp,state,m_op_Period_SMALL);      //避免重入關掉又開啟同方向
            g_Small_State = state;
         }   
      }else if(state==P3_Rev_L|| state==P4_Con_S ||state==P6_Cross_S){//不同方向          
            ReverseLong(price,sl,tp,state,m_op_Period_SMALL);
         g_Small_State = state;
       }  
     }//if(state != P0_CHECK){   
     price = m_symbol.Ask();
     state = filter2.MTF_CheckReverseShort(price,sl,tp,expiration);
     if(state != P0_CHECK ){//小週期期避免重入關掉又開啟同方向 && check_sl==false到
     // sl ,price 價格因取得時間會有變化,所以盡量在要使用的地方取得價格,避免時間落差滑掉
        tp = m_money.Get_TP(m_op_Period_SMALL,POSITION_TYPE_BUY);
        sl = m_money.Get_SL(m_op_Period_SMALL,POSITION_TYPE_BUY); //long
       if(g_Small_State ==P1_Rev_S || g_Small_State == P2_Con_L ||g_Small_State==P5_Cross_L ){
           //TODO 同方向 不關閉改用 open 
           if(state==g_Small_State && total>0)                 //避免重入關掉又開啟同方向
            printf("KK_Profolio Op reentrain "+ EnumToString(state) );
           else{
            OpenLong(price,sl,tp,state,m_op_Period_SMALL);      //避免重入關掉又開啟同方向
            g_Small_State = state;
            }
       }else if(state ==P1_Rev_S || state == P2_Con_L ||state==P5_Cross_L ){ //if(CheckReverseShort()) 
            //不同方向  
          // 中間價格變化,會導致重算 ~移到後面 前面不再比較確認 只傳入
          ReverseShort(price,sl,tp,state,m_op_Period_SMALL);          //expiration
       }              
       g_Small_State = state;

     }//if(state != P0_CHECK){
    }//if( m_test_mode  == 2|| m_test_mode ==3){
   
   return(true);
  }


    /*
//--- check if plased pending orders
   total=OrdersTotal();
   if(total!=0)
     {
      for(int i=total-1; i>=0; i--)
        {
         m_order.SelectByIndex(i);
         if(m_order.Symbol()!=m_symbol.Name())
            continue;
         if(m_order.OrderType()==ORDER_TYPE_BUY_LIMIT || m_order.OrderType()==ORDER_TYPE_BUY_STOP)
           {
            //--- check the ability to delete a pending order to buy
            if(CheckDeleteOrderLong())
               return(true);
            //--- check the possibility of modifying a pending order to buy
            if(CheckTrailingOrderLong())
               return(true);
           }
         else
           {
            //--- check the ability to delete a pending order to sell
            if(CheckDeleteOrderShort())
               return(true);
            //--- check the possibility of modifying a pending order to sell
            if(CheckTrailingOrderShort())
               return(true);
           }
         //--- return without operations
         return(false);
        }
     }*/
//--- check the possibility of opening a position/setting pending order

//--- return without operations
//+------------------------------------------------------------------+
//| Long position reverse                                            |
//+------------------------------------------------------------------+
bool CKExpert::ReverseLong(double price,double sl,double tp,ENUM_MT_POLICY state,ENUM_TIMEFRAMES operation_priod) //group
  {
      bool result=true;
   if(price==EMPTY_VALUE || !IsHedging())
      return(false);
  //  double lot=(m_money.CheckReverse(GetPointer(m_position),sl,operation_priod)); //--- get lot for reverse
   double   lots = KClose_Group( expert_policy,operation_priod,POSITION_TYPE_BUY ,m_position.Ticket(),m_trade);  //內部已關閉反向position 
   double lots_open_new = m_money.CheckOpen(expert_policy , POSITION_TYPE_SELL, 0.0, sl, operation_priod);
   if(lots_open_new==0.0 && lots<0.009)
      result=false;
   else{
         result=m_trade.Sell(lots_open_new,price,sl,tp,EnumToString(operation_priod)+"  "+EnumToString(state));
         m_trade.Result(Order_result);     
         KPolicy_Add_Order_Node(Order_result.order,state,operation_priod);      
         CChartObjectArrowDown *arrow=new CChartObjectArrowDown();
         datetime dt=TimeCurrent();
         if(m_arrows.Add(arrow)) {
          arrow.Create(0,"Sell_"+TimeToString(dt),0,dt,price);
          if(operation_priod>PERIOD_M30){
            if(state==P3_Rev_L)  arrow.Width(7);
            else                 arrow.Width(5);//P4_Con_S
          }else{
            if(state==P3_Rev_L)  arrow.Width(4);
            else                 arrow.Width(2);//P4_Con_S
          
          }
          arrow.Color(clrBlue);
        //  PlotIndexSetInteger(0,PLOT_ARROW_SHIFT,100);
        }else          
         delete arrow;
   }
     
//---
   return(result);
  }
//+------------------------------------------------------------------+
//| Short position reverse                                           |
//+------------------------------------------------------------------+
bool CKExpert::ReverseShort(double price,double sl,double tp,ENUM_MT_POLICY state,ENUM_TIMEFRAMES operation_priod)
  {
   bool result=true;
   if(price==EMPTY_VALUE || !IsHedging())
      return(false);
//--- get lot for reverse   //lot=LotCheck(lot,price,ORDER_TYPE_SELL);
  // double lots_open_new= m_money.CheckReverse(GetPointer(m_position),sl,operation_priod); 
   double   lots = KClose_Group( expert_policy,operation_priod,POSITION_TYPE_SELL ,m_position.Ticket(),m_trade);  //內部已關閉反向position 
  
   double   lots_open_new = m_money.CheckOpen(expert_policy , POSITION_TYPE_BUY,0.0, sl, operation_priod);
   if(lots_open_new==0.0 && lots<0.009)
      result=false;
   else{
         result = m_trade.Buy(lots_open_new,price,sl,tp,EnumToString(operation_priod)+"  "+EnumToString(state));
        // CKEAInfo *info = new CKEAInfo;  
         m_trade.Result(Order_result);      
         KPolicy_Add_Order_Node(Order_result.order,state,operation_priod);   //Because OnTrade maybe failed to no operation ~ we change to do operation immate after return.
         CChartObjectArrowUp *arrow =  new CChartObjectArrowUp();
         datetime dt =  TimeCurrent();
         if(m_arrows.Add(arrow))
           {
           arrow.Create(0,"Buy_Rev"+TimeToString(dt),0,dt,price);
           if(operation_priod>PERIOD_M30){
            if(state == P1_Rev_S)  arrow.Width(7);
            else                 arrow.Width(5);//P4_Con_S
            }else{
             if(state == P1_Rev_S)  arrow.Width(4);
            else                 arrow.Width(2);//P4_Con_S
            }
           arrow.Color(clrRed);
           }
         else delete arrow;
         } 
//---
   return(result);
  }
  
  
//+------------------------------------------------------------------+
//| Long position open or limit/stop order set                       |
//+------------------------------------------------------------------+
bool CKExpert::OpenLong(double price,double sl,double tp,ENUM_MT_POLICY policy,ENUM_TIMEFRAMES operation_priod)
  {
   if(price==EMPTY_VALUE)
      return(false);
//--- get lot for open
   double funlot= m_money.CheckOpen(expert_policy , POSITION_TYPE_BUY, 0.0, sl, operation_priod); //  LotOpen(POSITION_TYPE_BUY,  price, sl, operation_priod);// 
//--- check lot for open
   CChartObjectArrowUp *arrow=new CChartObjectArrowUp();
   datetime dt=TimeCurrent();
   if(m_arrows.Add(arrow))
      {
      arrow.Create(0,"Buy_"+TimeToString(dt),0,dt,price);
      arrow.Width(2);
      arrow.Color(clrRed);
      }
   else delete arrow;
   funlot=LotCheck(funlot,price,ORDER_TYPE_BUY);
   if(funlot==0.0)
      return(false);
//---
   
   if(m_trade.Buy(funlot,price,sl,tp,EnumToString(operation_priod)+" "+EnumToString(policy)+" dir"))
   {  
      m_trade.Result(Order_result);
      if(Order_result.deal!=0)
         KPolicy_Add_Order_Node(Order_result.order,policy,operation_priod);  //      KPolicy_Add_Order_Node(Order_result.order,policy,operation_priod); 
      else
         KPolicy_Add_Order_Node(Order_result.order,policy,operation_priod);  //      KPolicy_Add_Order_Node(Order_result.order,policy,operation_priod);    
      return (true); 
   }
   return(false);
  }
//+------------------------------------------------------------------+
//| Short position open or limit/stop order set                      |
//+------------------------------------------------------------------+
bool CKExpert::OpenShort(double price,double sl,double tp,ENUM_MT_POLICY policy,ENUM_TIMEFRAMES operation_priod)
  {
   if(price==EMPTY_VALUE)
      return(false);
//--- get lot for open
   double funlot=m_money.CheckOpen(expert_policy , POSITION_TYPE_SELL, 0.0, sl, operation_priod); //LotOpen(POSITION_TYPE_SELL,  price, sl, operation_priod);   //LotOpenShort(price,sl);
//--- check lot for open
   funlot=LotCheck(funlot,price,ORDER_TYPE_SELL);
   CChartObjectArrowDown *arrow = new CChartObjectArrowDown();
   datetime dt=TimeCurrent();
   if(m_arrows.Add(arrow))
   {
      arrow.Create(0,"Sell_"+TimeToString(dt),0,dt,price);
      arrow.Width(2);
      arrow.Color(clrBlue);
   }
   else delete arrow;
   if(funlot==0.0)
      return(false);
//---
   if(m_trade.Sell(funlot,price,sl,tp,EnumToString(operation_priod)+" "+EnumToString(policy)+" Dir")){
      m_trade.Result(Order_result);
      if(Order_result.deal!=0)
         KPolicy_Add_Order_Node(Order_result.order,policy,operation_priod);  //      KPolicy_Add_Order_Node(Order_result.order,policy,operation_priod);   
      else
         KPolicy_Add_Order_Node(Order_result.order,policy,operation_priod);    
      return (true);
   }
   return(false);
}  

ENUM_MT_POLICY CKExpert::ckReverseLong(ENUM_TIMEFRAMES operation_priod)
  {
   double   price=EMPTY_VALUE;
   double   sl=0.0;
   double   tp=0.0;
   datetime expiration=TimeCurrent();
   ENUM_MT_POLICY state;
//--- check signal for long reverse operations
 //  int    total=m_filters.Total();
   //--- try to get the levels of opening
   if( operation_priod > PERIOD_M30)
      state = filter1.MTF_CheckReverseLong(price,sl,tp,expiration);
   else
      state = filter2.MTF_CheckReverseLong(price,sl,tp,expiration);    
   if(state==P4_Con_S || state == P3_Rev_L ){
         int total=PositionsTotal();
         for(int i=0;i<total;i++){
         PositionSelect(_Symbol);//PositionSelectByTicket(ulong   ticket     // Position ticket
         if(m_position.PositionType()==POSITION_TYPE_BUY)
            CloseLong(price);//
         }
         if(ReverseLong(price,sl,tp,MTP_REVLONG,operation_priod))
            return state;
         else
            return state;   
    }
//--- return without operations
   return(false);
  }
//+------------------------------------------------------------------+
//| Check for short position reverse                                 |
//+------------------------------------------------------------------+
ENUM_MT_POLICY CKExpert::ckReverseShort(ENUM_TIMEFRAMES operation_priod)
  {
   double   price=EMPTY_VALUE;
   double   sl=0.0;
   double   tp=0.0;
   datetime expiration=TimeCurrent();
   ENUM_MT_POLICY state;
//--- check signal for short reverse operations
   if( operation_priod > PERIOD_M30)
       state = filter1.MTF_CheckReverseShort(price,sl,tp,expiration);//
   else
       state = filter2.MTF_CheckReverseShort(price,sl,tp,expiration);//    
   if(state==P1_Rev_S || state == P2_Con_L ){
      int total=PositionsTotal();
      for(int i=0;i<total;i++){
         PositionSelect(_Symbol);//PositionSelectByTicket(ulong   ticket     // Position ticket
         if(m_position.PositionType()==POSITION_TYPE_SELL) //<<<============================================
            CloseShort(price);//CheckCloseShort(); 
       }
       if(ReverseShort(price,sl,tp,MTP_REVSHORT,operation_priod))
        return(state);
       else
         return state; 
    }
//--- return without operations
   return(false);
  }
  
void CKExpert::OnTrade(void)
  {
  //DEAL_ENTRY_IN HistoryOrderGetTicket DEAL_TYPE
    //Debug  Print("OnTrade PID :",HistoryOrderGetInteger(HistoryOrderGetTicket(0),ORDER_POSITION_ID)," DEAL_POSITION_ID:",(ulong)HistoryDealGetInteger(HistoryDealGetTicket(0),DEAL_POSITION_ID)," ",HistoryDealGetInteger(HistoryDealGetTicket(0),DEAL_TICKET));
   // Print("OnTrade PID :",HistoryDealGetInteger(HistoryDealGetTicket(1),DEAL_TYPE)," DEAL_POSITION_ID:",HistoryDealGetInteger(HistoryDealGetTicket(1),DEAL_POSITION_ID)," ",HistoryDealGetInteger(HistoryDealGetTicket(1),DEAL_TICKET));

   if(Order_result.deal>0){
   //Print("OnTrade deal: ",Order_result.deal," -- order: ",Order_result.order);
      if( Trade(Order_result ) )//my_result.order my_result.dealTrade();   //m_pannel.Get_Result()
         m_new_order=false; 
   }
   if (hand_result.deal>0){
     // Print("hand_result OnTrade deal: --",hand_result.deal,"  order: ",hand_result.order);
         if( Trade(hand_result) )
            m_new_order=false; 
   }
   if(hand_result.deal==0 && Order_result.deal==0)
      Print("=====Check Close Deal?============="); 
    
         
  }
  
  
bool CKExpert::InitIndicators(CIndicators *indicators)
  {
//--- NULL always comes as the parameter, but here it's not significant for us
   CIndicators *indicators_ptr=GetPointer(m_indicators);
//--- gather information about using of timeseries
   m_used_series|=m_signal.UsedSeries();
   m_used_series|=m_trailing.UsedSeries();
   m_used_series|=m_money.UsedSeries();
//--- create required timeseries
   if(!CExpertBase::InitIndicators(indicators_ptr))
      return(false);
   m_signal.SetPriceSeries(m_open,m_high,m_low,m_close);
   m_signal.SetOtherSeries(m_spread,m_time,m_tick_volume,m_real_volume);
   if(!m_signal.InitIndicators(indicators_ptr))
     {
      Print(__FUNCTION__+": error initialization indicators of signal object");
      return(false);
     }
   m_trailing.SetPriceSeries(m_open,m_high,m_low,m_close);
   m_trailing.SetOtherSeries(m_spread,m_time,m_tick_volume,m_real_volume);
   if(!m_trailing.InitIndicators(indicators_ptr))//||!k_trailing2.InitIndicators(indicators_ptr
     {
      Print(__FUNCTION__+": error initialization indicators of trailing object");
      return(false);
     }
   m_money.SetPriceSeries(m_open,m_high,m_low,m_close);
   m_money.SetOtherSeries(m_spread,m_time,m_tick_volume,m_real_volume);
   if(!m_money.InitIndicators(indicators_ptr))
     {
      Print(__FUNCTION__+": error initialization indicators of money object");
      return(false);
     }
//--- ok
   return(true);
  } 
  
  
  
bool CKExpert::Init(string symbol,ENUM_TIMEFRAMES period,bool every_tick,ulong magic)
  {
//--- returns false if the EA is initialized on a symbol/timeframe different from the current one
   if(symbol!=::Symbol() || period!=::Period())
     {
      PrintFormat(__FUNCTION__+": wrong symbol or timeframe (must be %s:%s)",symbol,EnumToString(period));
      return(false);
     }
//--- initialize common information
   if(m_symbol==NULL)
     {
      if((m_symbol=new CSymbolInfo)==NULL)
         return(false);
     }
   if(!m_symbol.Name(symbol))
      return(false);
   panel_symbol      = m_symbol;//for panel   
   m_period    =period;
   m_every_tick=every_tick;
   m_magic     =magic;
   SetMarginMode();
   if(every_tick)
      TimeframeAdd(WRONG_VALUE);            // add all periods
   else
      TimeframeAdd(period);                 // add specified period
//--- tuning for 3 or 5 digits
   int digits_adjust=(m_symbol.Digits()==3 || m_symbol.Digits()==5) ? 10 : 1;
   m_adjusted_point=m_symbol.Point()*digits_adjust;
//--- initializing objects expert
   if(!InitTrade(magic))
     {
      Print(__FUNCTION__+": error initialization trade object");
      return(false);
     }
   if(!InitSignal())
     {
      Print(__FUNCTION__+": error initialization signal object");
      return(false);
     }
     
   if(!InitTrailing(NULL))//,NULL
     {
      Print(__FUNCTION__+": error initialization trailing object");
      return(false);
     }
   if(!InitMoney())
     {
      Print(__FUNCTION__+": error initialization money object");
      return(false);
     }
   if(!InitParameters())
     {
      Print(__FUNCTION__+": error initialization parameters");
      return(false);
     }
//--- initialization for working with trade history
   PrepareHistoryDate();
   HistoryPoint();
//--- primary initialization is successful, pass to the phase of tuning
   m_init_phase=INIT_PHASE_TUNING;
//--- ok
   return(true);
  }  
  
  

   
//+------------------------------------------------------------------+
//| Check for trailing stop/profit long position                     |
//+------------------------------------------------------------------+
bool CKExpert::CheckTrailingStopLong(ENUM_TIMEFRAMES group)
  {
   double sl=EMPTY_VALUE;
   double tp=EMPTY_VALUE;
//--- check for long trailing stop operations
   if(m_money.K_CheckTrailingStopLong( GetPointer(m_position),(ENUM_TIMEFRAMES)group,sl,tp))
     {
      double position_sl=m_position.StopLoss();
      double position_tp=m_position.TakeProfit();
      if(sl==EMPTY_VALUE)
         sl=position_sl;
      else
         sl=m_symbol.NormalizePrice(sl);
      if(tp==EMPTY_VALUE)
         tp=position_tp;
      else
         tp=m_symbol.NormalizePrice(tp);
      if(sl==position_sl && tp==position_tp)
         return(false);
      //--- long trailing stop operations
      return(TrailingStop(POSITION_TYPE_BUY,sl,tp,(ENUM_TIMEFRAMES)group));//magic buy_sell //ENUM_POSITION_TYPE check = ; //Short true Long false
     }
     
//--- return without operations
   return(false);
  }
//+------------------------------------------------------------------+
//| Check for trailing stop/profit short position                    |
//+------------------------------------------------------------------+
bool CKExpert::CheckTrailingStopShort(ENUM_TIMEFRAMES group)
  {
   double sl=EMPTY_VALUE;
   double tp=EMPTY_VALUE;
//--- check for short trailing stop operations
//(CPositionInfo *position,uint mtf,double &sl,double &tp)
   if(m_money.K_CheckTrailingStopShort(GetPointer(m_position),(ENUM_TIMEFRAMES)group,sl,tp)) //(ENUM_TIMEFRAMES) PERIOD_M10
     {
      double position_sl=m_position.StopLoss();
      double position_tp=m_position.TakeProfit();
      if(sl==EMPTY_VALUE)
         sl=position_sl;
      else
         sl=m_symbol.NormalizePrice(sl);
      if(tp==EMPTY_VALUE)
         tp=position_tp;
      else
         tp=m_symbol.NormalizePrice(tp);
      if(sl==position_sl && tp==position_tp)
         return(false);
      //--- short trailing stop operations
      return(TrailingStop(POSITION_TYPE_SELL,sl,tp,(ENUM_TIMEFRAMES)group));//magic buy_sell //ENUM_POSITION_TYPE check = ; //Short true Long false
     }
//--- return without operations
   return(false);
  }   
  
bool CKExpert::CheckTrailingStop(ENUM_POSITION_TYPE buy_sell, ENUM_TIMEFRAMES group)
  {
   double sl=EMPTY_VALUE;
   double tp=EMPTY_VALUE;
   bool op_go;
   if(!flag_tailing) return (false);
//--- check for long trailing stop operations
   if(buy_sell==POSITION_TYPE_BUY)
      op_go=m_money.K_CheckTrailingStopLong( GetPointer(m_position),group,sl,tp);
   else
      op_go=m_money.K_CheckTrailingStopShort( GetPointer(m_position),group,sl,tp);
   if(op_go)
     {
      double position_sl=m_position.StopLoss();
      double position_tp=m_position.TakeProfit();
      if(sl==EMPTY_VALUE)
         sl=position_sl;
      else
         sl=m_symbol.NormalizePrice(sl);
      if(tp==EMPTY_VALUE)
         tp=position_tp;
      else
         tp=m_symbol.NormalizePrice(tp);
      if(sl==position_sl && tp==position_tp)
         return(false);
      //--- long trailing stop operations
      if(TrailingStop(buy_sell,sl,tp,group))
         return(true);
      else
         Print(__FUNCTION__,EnumToString((ENUM_TIMEFRAMES)group)," Ticket: ",m_position.Ticket()," failed");  
     }
     
//--- return without operations
   
   return(false);
  }
  
bool CKExpert::CheckTrailingStop(ulong ticket)
{//--- position must be selected before call
 return false;
}
   /*  if(ea_deal___group.TryGetValue(ticket-1,group)){   
       if(CheckTrailingStop(m_position.PositionType(),(ENUM_TIMEFRAMES)group))
          return(true); 
       printf("CheckTrailingStop failed Try limeit order Ticket %d ===  Total %d", ticket-1,ea_deal___group.Count() ); //}   
   */
void CKExpert::OnTimer(void)
  {
   int total=PositionsTotal();
   ulong ticket;
   long curr_tm   = TimeCurrent();//TimeLocal();
   long op_pos_tm =0;
   long pasttime;
   int group=0;
   double tp,sl,price_open,profit;
   bool result;
   static int count=0;
   ENUM_POSITION_TYPE direction;
   printf("======Expert_Timer============Expert_Timer========Expert_Timer===============");
   
   if(count%3==2){
      m_money.OnTimer();//Update last SAR
      Print("tailingtaintingtailing",profit);
   }else{
      total=0;
      Print(">>>>>>>>>>===============OnTimer==================== ! Profit<<<<<=================");
   }
   count ++;
   if(total>0){
       for(int i=0;i<total;i++){
         ticket=PositionGetTicket(i);        // bool PositionSelect(_Symbol);
         if(m_position.Select(_Symbol)){  
            op_pos_tm = (long)(m_position.TimeMsc()/1000);
            pasttime  = curr_tm - op_pos_tm ; 
            bool check1= pasttime> 60* m_timeout_small && pasttime < 60 * m_timeout_small+2;
            bool check2= pasttime> 60* m_timeout_big && pasttime < 60 * m_timeout_big+2;
            if(check1 || check2){
               ea_order__group.TryGetValue(ticket,group);
               profit = m_position.TakeProfit();
               tp = m_position.TakeProfit();
               sl = m_position.StopLoss();
               price_open=m_position.PriceOpen();
               direction =m_position.PositionType();
               double safty=0.00080;
               Print(">>>>>>>>>>===============OnTimer==================== ! Profit<<<<<=================",profit);
               if(check1 && group < m_op_Period_BIG){ 
                  safty=0.00005;
                  if(m_position.Profit() < 1.0 ){ 
                      result =  m_trade.PositionClose (ticket,20);    
                  }else { 
                     
                       if(direction==POSITION_TYPE_BUY)
                        {  
                           if(sl < price_open+safty)
                              result =  m_trade.PositionModify(ticket,(sl + m_position.PriceCurrent())/2 ,( m_position.PriceCurrent()*2 + tp )/3,"TimeOut update SL/TP");   
                        }
                        else{
                           if(sl > price_open-safty)
                              result =  m_trade.PositionModify(ticket,(sl+  m_position.PriceCurrent())/2 ,( m_position.PriceCurrent()*2 + tp )/3,"TimeOut update SL/TP");
                        }
                   }//Lock to win           
              }
              if(check2 && group == m_op_Period_BIG){
                   if(m_position.Profit() <0.10 ){ 
                      result =  m_trade.PositionClose (ticket,20);    
                  }else { 
                        if(direction==POSITION_TYPE_BUY)
                        {  
                           if(sl < price_open+safty)
                              result =  m_trade.PositionModify(ticket,price_open + safty ,tp,"TimeOut update SL/TP");   
                        }
                        else{
                           if(sl > price_open-safty)
                              result =  m_trade.PositionModify(ticket,price_open - safty ,tp,"TimeOut update SL/TP");
                        }
                   }//Lock to win 
              }//Group operation    
      }//timeout
   }//sample
   }}//for
   
//--- check process flag
   if(!m_on_timer_process)
      return;
  }
  
  bool CKExpert::TrailingStop(ENUM_POSITION_TYPE buy_sell,double sl,double tp,ENUM_TIMEFRAMES group)
  {
   bool result;
//---
   if(IsHedging()){
      result=m_trade.PositionModify(m_position.Ticket(),sl,tp,EnumToString(group) + "   Tailing");
   }else{
      result=m_trade.PositionModify(m_symbol.Name(),sl,tp);
      }
//---
   Print(__FUNCTION__," ",EnumToString((ENUM_TIMEFRAMES)group)," Ticket: ",m_position.Ticket()," sl : ",sl," ",result);
   return(result);
  }

double CKExpert::LotOpen(ENUM_POSITION_TYPE buy_sell,double price,double sl,ENUM_TIMEFRAMES op_priod)
  {
   return (m_money.CheckOpen(expert_policy , buy_sell,  0.0, sl, op_priod)) ;   //money_policy
  }